.TH CUSTOM TCL "" "TCL - Tool Command Language"
.ad b
.SH NAME
custom_info - Return information about the customized TCL environment.
.SH SYNOPSIS
.B custom_info \fIitem\fR
.SH DESCRIPTION
.PP
'@help: extend/custom_info
.B custom_info \fIitem\fR
.br
Returns information about the customized TCL environment in the current TCL
application.  The following values may be specified for \fIitem\fR:
.br
.IP \fBinitfile\fR 4
.br
Returns the full pathname of the TCL initialization file.
.br
.IP \fBname\fR 4
.br
Returns the name of the custom version of TCL.
.br
.IP \fBlongname\fR 4
.br
Returns a one-line description of the custom version of TCL.
.br
.IP \fBversion\fR 4
.br
Returns the revision number of the custom version.
.br
.IP \fBpatchlevel\fR 4
.br
Returns the patch level of the current custom version.
.br
.IP \fBsourcedir\fR 4
.br
Returns the default custom source directory for TCL command files.
.br
'@endhelp
.SH INITIALIZATION
To initialize the \fBcustom_info\fR TCL command in a custom TCL environment
call:
.sp
.nf
.ft CW
    void TCL_InitCustom (interp)
           Tcl_Interp *interp;
.ft R
.fi
