.TH DEBUG TCL "" "TCL - Tool Command Language"
.ad b
.SH NAME
trace - TCL debugging commands.
.SH SYNOPSIS
.B trace \fIlevel\fR [\fBnoeval\fR] [\fBnotruncate\fR]
.br
.B trace off
.br
.B trace depth
.br
.SH DESCRIPTION
.PP
'@help: debug/trace
.B trace \fIlevel\fR [\fBnoeval\fR] [\fBnotruncate\fR]
.br
Print a trace statement for all commands executed at depth of \fIlevel\fR or
below (1 is the top level).  If \fBnoeval\fR is specified, arguments are
printed unevaluated, if it is not specified, the arguments are printed after
evaluation. If the command line is longer than 60 characters, it is truncated
to 60 and a "..." is postpended to indicate that there was more. If
\fBnoeval\fR wasn't specified, the arguments are printed after evaluation.  In
this case, each argument is truncated to 40 characters (with "..." postpended 
if the argument was longer than 40 characters) and printed. If an evaluated 
argument contains a space, the entire argument will be enclosed inside angle
brackets ("<>") to allow the reader to visually separate the arguments from
each other. If \fBnotruncate\fR is specified, then the truncation of commands
and evaluated arguments will be disabled.
.PP
.B trace off
.br
Turn off all tracing.
.PP
.B trace depth
.br
Returns the current maximum trace level, or zero if trace is disabled.
'@endhelp
.SH INITIALIZATION
.PP      
To initialize the debugging commands in a custom TCL environment call:
.sp
.nf
.ft CW
    void TCL_InitDebug (interp)
           Tcl_Interp *interp;
.ft R
.fi
      

