#
# this cracks the super-gross mail.log file produced by smail 2.5 if
# you compile smail with the option enabled, and produces three
# reports and totals:
#
# mail queued from your system to the net
# mail received by your system from the net
# mail routed through your system by someone on the net to someplace
#   else on the net
#
# right now it says "sugar" for your site, but it can do a exec uname
# to get the real name in some subsequent incarnation
#
#

global logname 

set logname /usr/lib/smail/mail.log

global logfp totalbytes totalparcels
global parcels_sugar_queued bytes_sugar_queued
global parcels_sugar_received bytes_sugar_received
global parcels_through_sugar bytes_through_sugar
global parcels_local_to_sugar bytes_local_to_sugar

set totalbytes 0; set totalparcels 0
set parcels_sugar_queued 0; set bytes_sugar_queued 0
set parcels_sugar_received 0; set bytes_sugar_received 0
set parcels_through_sugar 0; set bytes_through_sugar 0
set parcels_local_to_sugar 0; set bytes_local_to_sugar 0

set logfp [open $logname r]

exec rm -f /tmp/ml.fromsugar /tmp/ml.tosugar /tmp/ml.throughsugar

global fromprop toprop throughprop
global from_machine_prop to_machine_prop

set fromprop [prop open /tmp/ml.fromsugar]
set toprop [prop open /tmp/ml.tosugar]
set throughprop [prop open /tmp/ml.throughsugar]

proc add_to_prop {proplist entry value} {
	set a [prop get $proplist $entry]
	if {[string match $a ""]} { set a $value } else {incr a $value}
	prop put $proplist [concat $entry 0] $a
}

proc collect {} {
	global logfp totalbytes totalparcels
	global parcels_sugar_received bytes_sugar_received
	global parcels_sugar_queued bytes_sugar_queued
	global parcels_through_sugar bytes_through_sugar
	global parcels_local_to_sugar bytes_local_to_sugar
	global fromprop toprop throughprop

	while {[gets $logfp line]} {
		set logline [split "\t" $line]
		incr totalparcels
		set message_length [index $logline 1]
		incr totalbytes $message_length
		set sender [index $logline 2]
		set command [index $logline 3]
		set splitsender [split ! $sender]
		set local_sender [expr {[length $splitsender] == 1}]

		case [index $command 0] \
			/bin/lmail {
				set local_recepient 1
			} \
			/usr/bin/uux {
				set local_recepient 0
			} \
			default {
				puts file2 [format "unrecognized program: %s\n" $command]
			}

		if {$local_recepient && !$local_sender} {
			incr parcels_sugar_received
			incr bytes_sugar_received $message_length
			add_to_prop $toprop $sender $message_length
		}
		if {$local_recepient && $local_sender} {
			incr parcels_local_to_sugar
			incr bytes_local_to_sugar $message_length
		}
		if {$local_sender && !$local_recepient} {
			incr parcels_sugar_queued
			incr bytes_sugar_queued $message_length
			add_to_prop $fromprop $sender $message_length
		}
		if {!$local_sender && !$local_recepient} {
			incr parcels_through_sugar
			incr bytes_through_sugar $message_length
			add_to_prop $throughprop $sender $message_length
		}
	}
}

proc totals {} {
	global totalbytes totalparcels
	global parcels_sugar_received bytes_sugar_received
	global parcels_sugar_queued bytes_sugar_queued
	global parcels_through_sugar bytes_through_sugar
	global parcels_local_to_sugar bytes_local_to_sugar

	print [format "%d messages from net to sugar (%d bytes)\n" $parcels_sugar_received $bytes_sugar_received]
	print [format "%d messages from sugar to net (%d bytes)\n" $parcels_sugar_queued $bytes_sugar_queued]
	print [format "%d messages through sugar (%d bytes)\n" $parcels_through_sugar $bytes_through_sugar]
	print [format "%d messages local to sugar (%d bytes)\n" $parcels_local_to_sugar $bytes_local_to_sugar]
	print [format "%d total messages (%d bytes)\n" $totalparcels $totalbytes]
}

collect

totals
