package directory_stack pushd popd

#@help: tcl.tlib/pushd
#
# pushd
# pushd directory
# popd
# dirs
#
# "pushd [dir]" pushes the current directory onto directory stack and cd's
# to "dir" if specified.
#
# popd pops the directory stack and cd to the popped entry.
#
# "dirs" lists the directory stack
#
#@endhelp

global dir_push_list

set dir_push_list ""

proc pushd {args} {
	global dir_push_list

	set dir_push_list [concat [pwd] $dir_push_list]

	if {[length $args] != 0} {
		if {[length $args] != 1} {
			error "bad # args: pushd [dir_to_cd_to]"
		}
		cd [glob $args]
	}
}

proc popd {} {
	global dir_push_list

	if [length $dir_push_list] {
		cd [replace dir_push_list 0]
	} else {
		echo "directory stack empty"
	}
}

proc dirs {} { global dir_push_list ; echo $dir_push_list }
