#
# bigprompt - redefine your Tcl prompt to be more interesting
#
# if you do a source of bigprompt.tcl, you'll get your current directory,
# the tcl history index if history was compiled in, and the name the
# program was invoked as followed by a >
#
#
global HOME
set HOME [getenv HOME]

rename cd old_cd

global CWD
set CWD [pwd]

proc cd {{dir {}}} {
	global CWD HOME

	if [strequ $dir ""] {set dir $HOME}

	old_cd $dir
	if [strequ [cindex $dir 0] /] {
		set CWD $dir
	} else {
		if [string match *..* $dir] {
			set CWD [pwd]
		} else {
			if [string match ./* $dir] {set dir [crange $dir 2 end]}
			if [strequ $CWD /] {
				set CWD /$dir
			} else {
				set CWD $CWD/$dir
			}
		}
	}
}

if [strequ [info commands history] ""] {
	proc big_prompt_proc {} {
		global CWD programName
		return [format "%s %s> " $CWD $programName]
	}
} else {
	proc big_prompt_proc {} {
		global CWD programName
		return [format "%s %s %s> " $CWD [history nextid] $programName]
	}
}

set toplevel_prompt_hook big_prompt_proc
